"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _instance = _interopRequireDefault(require("./instance.js"));

var _reactDom = require("react-dom");

var _excluded = ["portal", "overflowContainer", "indexs"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var IndexBar = (0, _react.forwardRef)(function (_ref, ref) {
  var portal = _ref.portal,
      overflowContainer = _ref.overflowContainer,
      _ref$indexs = _ref.indexs,
      indexs = _ref$indexs === void 0 ? ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'G', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'] : _ref$indexs,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var barRef = (0, _react.useRef)(null);
  var toolTipRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return barRef.current;
  });
  var instance = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    instance.current = new _instance["default"]({
      overflowContainer: overflowContainer || barRef.current.parentNode,
      parent: portal || barRef.current.parentNode,
      bar: barRef.current,
      tooltip: toolTipRef.current
    });
  }, []); // eslint-disable-line

  var DOM = /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement("div", _extends({
    ref: barRef
  }, others, {
    className: "indexbar" + (others.className ? ' ' + others.className : '')
  }), indexs.map(function (index, i) {
    return /*#__PURE__*/_react["default"].createElement("span", {
      className: "indexbar-button",
      key: "btn" + i
    }, index);
  })), /*#__PURE__*/_react["default"].createElement("div", {
    ref: toolTipRef,
    className: "indexbar-tooltip"
  }));

  if (portal) {
    return (0, _reactDom.createPortal)(DOM, portal);
  }

  return DOM;
});
var _default = IndexBar;
exports["default"] = _default;
module.exports = exports.default;