"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _jcrop = _interopRequireDefault(require("jcrop"));

require("jcrop/dist/jcrop.css");

var _excluded = ["src", "rect", "scale", "options", "onChange", "style"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// Jcrop
var Jcrop = (0, _react.forwardRef)(function (_ref, ref) {
  var src = _ref.src,
      rect = _ref.rect,
      _ref$scale = _ref.scale,
      scale = _ref$scale === void 0 ? [0.7, 0.5] : _ref$scale,
      _ref$options = _ref.options,
      options = _ref$options === void 0 ? {
    multi: false
  } : _ref$options,
      onChange = _ref.onChange,
      style = _ref.style,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var rootRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return rootRef.current;
  });
  useEffect(function () {
    update();
  }, []); // eslint-disable-line

  function formatPos(argPos) {
    var pos = argPos;

    for (var n in argPos) {
      if (n === 'h') pos['height'] = argPos[n];else if (n === 'w') pos['width'] = argPos[n];
    }

    return pos;
  }

  function update() {
    if (!src || rootRef.current) return;

    _jcrop["default"].load(rootRef.current).then(function (img) {
      var jcp = _jcrop["default"].attach(img, options);

      var frame = null;
      var pos = {}; // 按尺寸创建

      if (rect) {
        pos = {
          x: rect[0],
          y: rect[1],
          w: rect[2],
          h: rect[3]
        };
        frame = _jcrop["default"].Rect.create(pos.x, pos.y, pos.w, pos.h);
        jcp.newWidget(frame); // 按比例创建
      } else {
        var _frame;

        frame = _jcrop["default"].Rect.sizeOf(jcp.el);
        pos = (_frame = frame).scale.apply(_frame, scale).center(frame.w, frame.h);
        jcp.newWidget(pos);
      }

      if (onChange) onChange({
        pos: formatPos(pos),
        src: src
      });
      jcp.listen('crop.change', function (widget, e) {
        pos = formatPos(widget.pos);
        if (onChange) onChange({
          pos: pos,
          src: src
        });
      });
    })["catch"](function (err) {
      console.error(err);
    });
  }

  return /*#__PURE__*/_react["default"].createElement("img", _extends({
    alt: "",
    ref: rootRef
  }, others, {
    style: Object.assign({
      maxWidth: '100%'
    }, style),
    src: src
  }));
});
var _default = Jcrop;
exports["default"] = _default;
module.exports = exports.default;