"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = require("react-dom");

var _excluded = ["portal", "show", "animation", "duration", "onClick", "maskAttribute", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Popover = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Popover, _Component);

  function Popover(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "componentDidMount", function () {});

    _defineProperty(_assertThisInitialized(_this), "onClick", function (e) {
      e.stopPropagation();
    });

    return _this;
  }

  var _proto = Popover.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        portal = _this$props.portal,
        show = _this$props.show,
        animation = _this$props.animation,
        duration = _this$props.duration,
        onClick = _this$props.onClick,
        _this$props$maskAttri = _this$props.maskAttribute,
        maskAttribute = _this$props$maskAttri === void 0 ? {} : _this$props$maskAttri,
        children = _this$props.children,
        others = _objectWithoutPropertiesLoose(_this$props, _excluded); // 构建动画


    var animationClassName = '';

    if (animation !== 'none') {
      animationClassName = 'popup-animation';
    } // 动画时长


    var durationStyle = {};

    if (typeof duration === 'number') {
      durationStyle = {
        WebkitTransitionDuration: duration + 'ms'
      };
    }

    return (0, _reactDom.createPortal)( /*#__PURE__*/_react["default"].createElement("div", _extends({
      ref: function ref(el) {
        _this2.$el = el;
      }
    }, maskAttribute, {
      className: "mask popover-mask" + (maskAttribute.className ? ' ' + maskAttribute.className : '') + (show ? ' active' : ''),
      style: Object.assign({}, durationStyle, maskAttribute.style || {})
    }), /*#__PURE__*/_react["default"].createElement("div", _extends({}, others, {
      className: "popover" + (animationClassName ? ' ' + animationClassName : '') + (others.className ? ' ' + others.className : '') + (show ? ' active' : ''),
      style: Object.assign({}, durationStyle, others.style || {}),
      "data-animation": animation,
      onClick: onClick ? onClick : this.onClick
    }), children && children)), portal || document.getElementById('root') || document.body);
  };

  return Popover;
}(_react.Component);

exports["default"] = Popover;

_defineProperty(Popover, "defaultProps", {
  animation: 'zoom'
});

Popover.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: _propTypes["default"].object,
  show: _propTypes["default"].bool,
  animation: _propTypes["default"].string,
  // slideLeft | slideRight | slideUp | slideDown | zoom | fade
  onClick: _propTypes["default"].func,
  maskAttribute: _propTypes["default"].object,
  children: _propTypes["default"].node
} : {};
module.exports = exports.default;