"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _Swiper = _interopRequireDefault(require("./../Swiper"));

var _excluded = ["onHide", "onChange", "defaultIndex", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var clickSpace = null;
var Swipe = (0, _react.forwardRef)(function (_ref, ref) {
  var onHide = _ref.onHide,
      onChange = _ref.onChange,
      defaultIndex = _ref.defaultIndex,
      children = _ref.children,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  // 初始化轮播
  function initHandler(s) {
    s.slideTo(defaultIndex, 0);
  } // 点击事件: 防止与放大缩小的双击事件冲突


  function clickHandler(s, e) {
    if (e.target.classList.contains('swiper-button-prev') || e.target.classList.contains('swiper-button-next')) {
      return;
    }

    if (clickSpace) {
      window.clearTimeout(clickSpace);
      clickSpace = null;
    }

    clickSpace = setTimeout(function () {
      if (onHide) onHide(s, e);
    }, 500);
  }

  function zoomHandler() {
    if (clickSpace) {
      window.clearTimeout(clickSpace);
      clickSpace = null;
    }
  }

  return (0, _reactDom.createPortal)( /*#__PURE__*/_react["default"].createElement(_Swiper["default"], _extends({
    ref: ref,
    className: "preview-swiper",
    params: {
      zoom: true,
      pagination: {
        el: '.swiper-pagination'
      },
      // navigation: {
      //   nextEl: '.swiper-button-next',
      //   prevEl: '.swiper-button-prev',
      // },
      on: {
        init: initHandler,
        tap: clickHandler,
        zoomChange: zoomHandler,
        slideChange: onChange
      }
    }
  }, others), children), document.getElementById('root') || document.body);
});
var _default = Swipe;
exports["default"] = _default;
module.exports = exports.default;